; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_INITIALISIEREN:
	sbi (DCF0_DDR) ,(DCF0_PIN)	; Ausgang-0 auf Ausgang		
	cbi (DCF0_PORT),(DCF0_PIN)	; Ausgang-0 auf LOW			

	sbi (DCF1_DDR) ,(DCF1_PIN)	; Ausgang-1 auf Ausgang		
	sbi (DCF1_PORT),(DCF1_PIN)	; Ausgang-1 auf HIGH		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_BEREICH_SENDEN:
	; Z-initialisieren	
	ldi ZL,LOW (adr_DCF_BEREICH)
	ldi ZH,HIGH(adr_DCF_BEREICH)
	LDS temp,(adr_ss)
	add ZL,temp
	adc ZH,NULL
	LD temp,Z	; Z--> temp
	rcall DCF_PIN_SCHALTEN_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_PIN_SCHALTEN_TEMP:
	cpi temp,0
	breq DCF_PIN_SCHALTEN_LOW_IMPULS
	cpi temp,1
	breq DCF_PIN_SCHALTEN_HIGH_IMPULS
	cpi temp,255
	breq DCF_PIN_SCHALTEN_MINUTENANFANG_IMPULS
	; ERROR	
	cbi PORTD,LED_D_ROT		; ROT	
	ret
;-------------------------------------------------------------------------------
DCF_PIN_SCHALTEN_LOW_IMPULS:
	sbi (DCF0_PORT),(DCF0_PIN)	; Ausgang-0 auf HIGH		
	cbi (DCF1_PORT),(DCF1_PIN)	; Ausgang-1 auf LOW			
	cbi PORTD,LED_D_GRUEN		; GRN						
	rcall wait_100ms			; 100ms Pause				
	sbi PORTD,LED_D_GRUEN		; GRN						
	cbi (DCF0_PORT),(DCF0_PIN)	; Ausgang-0 auf LOW			
	sbi (DCF1_PORT),(DCF1_PIN)	; Ausgang-1 auf HIGH		
	ret
;-------------------------------------------------------------------------------
DCF_PIN_SCHALTEN_HIGH_IMPULS:
	sbi (DCF0_PORT),(DCF0_PIN)	; Ausgang-0 auf HIGH		
	cbi (DCF1_PORT),(DCF1_PIN)	; Ausgang-1 auf LOW			
	cbi PORTD,LED_D_GRUEN		; GRN						
	rcall wait_100ms			; 200ms Pause				
	rcall wait_100ms			;							
	sbi PORTD,LED_D_GRUEN		; GRN						
	cbi (DCF0_PORT),(DCF0_PIN)	; Ausgang-0 auf LOW			
	sbi (DCF1_PORT),(DCF1_PIN)	; Ausgang-1 auf HIGH		
	ret
;-------------------------------------------------------------------------------
DCF_PIN_SCHALTEN_MINUTENANFANG_IMPULS:
	cbi PORTD,LED_D_GELB		; GELB 	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_BEREICH_BERECHNEN:
;0	Start einer neuen Minute (ist immer "0") 	
	STS(adr_DCF_BEREICH+59),NULL
;1-16 Reserviert									
	STS(adr_DCF_BEREICH+1),NULL
	STS(adr_DCF_BEREICH+2),NULL
	STS(adr_DCF_BEREICH+3),NULL
	STS(adr_DCF_BEREICH+4),NULL
	STS(adr_DCF_BEREICH+5),NULL
	STS(adr_DCF_BEREICH+6),NULL
	STS(adr_DCF_BEREICH+7),NULL
	STS(adr_DCF_BEREICH+8),NULL
	STS(adr_DCF_BEREICH+9),NULL
	STS(adr_DCF_BEREICH+10),NULL
	STS(adr_DCF_BEREICH+11),NULL
	STS(adr_DCF_BEREICH+12),NULL
	STS(adr_DCF_BEREICH+13),NULL
	STS(adr_DCF_BEREICH+14),NULL
	STS(adr_DCF_BEREICH+15),NULL
	STS(adr_DCF_BEREICH+16),NULL
;17	Sommerzeit aktiv (0: MEZ, "1": MESZ )		
	LDS temp,(adr_SOMMERZEIT)
	STS(adr_DCF_BEREICH+17),temp
;18	Winterzeit aktiv							
	STS(adr_DCF_BEREICH+18),NULL
;19	Ankndigung Schaltsekunde					
	STS(adr_DCF_BEREICH+19),NULL
;20	Beginn der Zeitinformation (ist immer "1") 	
	STS(adr_DCF_BEREICH+20),EINS
; ##############################################################################
	;---------------------------
	; BERECHNUNG BITS (Minute)	
	LDS temp,(adr_mm)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;21	Minute 1 									
	STS(adr_DCF_BEREICH+21),TEMP1
;22	Minute 2									
	STS(adr_DCF_BEREICH+22),TEMP2
;23	Minute 4									
	STS(adr_DCF_BEREICH+23),TEMP3
;24	Minute 8									
	STS(adr_DCF_BEREICH+24),TEMP4
;25	Minute 10									
	STS(adr_DCF_BEREICH+25),TEMP5
;26	Minute 20									
	STS(adr_DCF_BEREICH+26),TEMP6
;27	Minute 40									
	STS(adr_DCF_BEREICH+27),TEMP7
;28	Paritt Minute (Anzahl Bits=gerade=0)		
	clr temp1
	LDS temp,(adr_DCF_BEREICH+21)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+22)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+23)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+24)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+25)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+26)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+27)
	add temp1,temp
	andi temp1,0b00000001			; Bitmuster
	STS(adr_DCF_BEREICH+28),temp1	; Prfsumme
; ##############################################################################
	;---------------------------
	; BERECHNUNG BITS (STUNDE)	
	LDS temp,(adr_hh)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;29	Stunde 1 									
	STS(adr_DCF_BEREICH+29),temp1
;30	Stunde 2									
	STS(adr_DCF_BEREICH+30),temp2
;31	Stunde 4									
	STS(adr_DCF_BEREICH+31),temp3
;32	Stunde 8									
	STS(adr_DCF_BEREICH+32),temp4
;33	Stunde 10									
	STS(adr_DCF_BEREICH+33),temp5
;34	Stunde 20									
	STS(adr_DCF_BEREICH+34),temp6
;35	Paritt STUNDE (Anzahl Bits=gerade=0)		
	clr temp1
	LDS temp,(adr_DCF_BEREICH+29)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+30)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+31)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+32)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+33)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+34)
	add temp1,temp
	andi temp1,0b00000001			; Bitmuster
	STS(adr_DCF_BEREICH+35),temp1	; Prfsumme
; ##############################################################################
	;---------------------------
	; BERECHNUNG BITS (TAG)	
	LDS temp,(adr_TAG)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;36	Tag 1    									
	STS(adr_DCF_BEREICH+36),TEMP1
;37	Tag 2										
	STS(adr_DCF_BEREICH+37),TEMP2
;38	Tag 4										
	STS(adr_DCF_BEREICH+38),TEMP3
;39	Tag 8										
	STS(adr_DCF_BEREICH+39),TEMP4
;40	Tag 10										
	STS(adr_DCF_BEREICH+40),TEMP5
;41	Tag 20										
	STS(adr_DCF_BEREICH+41),TEMP6
	;---------------------------
	; BERECHNUNG BITS (WOCHENTAG)	
	LDS temp,(adr_WOCHENTAG)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;42	Wochentag 1									
	STS(adr_DCF_BEREICH+42),temp1
;43	Wochentag 2									
	STS(adr_DCF_BEREICH+43),temp2
;44	Wochentag 4									
	STS(adr_DCF_BEREICH+44),temp3
	;---------------------------
	; BERECHNUNG BITS (MONAT)	
	LDS temp,(adr_MONAT)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;45	Monat 1										
	STS(adr_DCF_BEREICH+45),TEMP1
;46	Monat 2										
	STS(adr_DCF_BEREICH+46),TEMP2
;47	Monat 4										
	STS(adr_DCF_BEREICH+47),TEMP3
;48	Monat 8										
	STS(adr_DCF_BEREICH+48),TEMP4
;49	Monat 10									
	STS(adr_DCF_BEREICH+49),TEMP5
	;---------------------------
	; BERECHNUNG BITS (JAHR)	
	LDS temp,(adr_JAHR)
	rcall DCF_SONDERFUNKTION_TEMP
	;---------------------------
;50	Jahr 1										
	STS(adr_DCF_BEREICH+50),TEMP1
;51	Jahr 2										
	STS(adr_DCF_BEREICH+51),TEMP2
;52	Jahr 4										
	STS(adr_DCF_BEREICH+52),TEMP3
;53	Jahr 8										
	STS(adr_DCF_BEREICH+53),TEMP4
;54	Jahr 10										
	STS(adr_DCF_BEREICH+54),TEMP5
;55	Jahr 20										
	STS(adr_DCF_BEREICH+55),TEMP6
;56	Jahr 40										
	STS(adr_DCF_BEREICH+56),TEMP7
;57	Jahr 80										
	STS(adr_DCF_BEREICH+57),TEMP8
;58	Paritt DATUM (Anzahl Bits=gerade=0)		
	clr temp1
	LDS temp,(adr_DCF_BEREICH+36)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+37)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+38)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+39)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+40)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+41)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+42)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+43)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+44)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+45)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+46)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+47)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+48)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+49)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+50)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+51)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+52)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+53)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+54)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+55)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+56)
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+57)
	add temp1,temp
	andi temp1,0b00000001			; Bitmuster
	STS(adr_DCF_BEREICH+58),temp1	; Prfsumme
; ##############################################################################
;59 Minutenerkennung (kein Impuls)				
	STS(adr_DCF_BEREICH+59),VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: 	temp																	
;																				
; OUT:	temp1 (1)																
;		temp2 (2)																
;		temp3 (4)																
;		temp4 (8)																
;		temp5 (10)																
;		temp6 (20)																
;		temp7 (40)																
;		temp8 (80)																
;																				
DCF_SONDERFUNKTION_TEMP:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	clr temp5
	clr temp6
	clr temp7
	clr temp8
	; >= 100 ?	
	cpi temp,100
	brlo DCF_SONDERFUNKTION_TEMP_START
	; ERROR		
	cbi PORTD,LED_D_ROT		; ROT	
	ret
DCF_SONDERFUNKTION_TEMP_START:
;-------------------------------------------------------------------------------
	; -80	
	mov temp8,EINS
	subi temp,(80)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP8_OK
	; +80	
	subi temp,(-80)
	clr temp8
DCF_SONDERFUNKTION_TEMP8_OK:
;-------------------------------------------------------------------------------
	; -40	
	mov temp7,EINS
	subi temp,(40)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP7_OK
	; +40	
	subi temp,(-40)
	clr temp7
DCF_SONDERFUNKTION_TEMP7_OK:
;-------------------------------------------------------------------------------
	; -20	
	mov temp6,EINS
	subi temp,(20)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP6_OK
	; +20	
	subi temp,(-20)
	clr temp6
DCF_SONDERFUNKTION_TEMP6_OK:
;-------------------------------------------------------------------------------
	; -10	
	mov temp5,EINS
	subi temp,(10)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP5_OK
	; +10	
	subi temp,(-10)
	clr temp5
DCF_SONDERFUNKTION_TEMP5_OK:
;-------------------------------------------------------------------------------
	; -8	
	mov temp4,EINS
	subi temp,(8)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP4_OK
	; +8	
	subi temp,(-8)
	clr temp4
DCF_SONDERFUNKTION_TEMP4_OK:
;-------------------------------------------------------------------------------
	; -4	
	mov temp3,EINS
	subi temp,(4)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP3_OK
	; +4	
	subi temp,(-4)
	clr temp3
DCF_SONDERFUNKTION_TEMP3_OK:
;-------------------------------------------------------------------------------
	; -2	
	mov temp2,EINS
	subi temp,(2)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP2_OK
	; +2	
	subi temp,(-2)
	clr temp2
DCF_SONDERFUNKTION_TEMP2_OK:
;-------------------------------------------------------------------------------
	; -1	
	mov temp1,EINS
	subi temp,(1)
	tst temp
	brpl DCF_SONDERFUNKTION_TEMP1_OK
	; +1	
	subi temp,(-1)
	clr temp1
DCF_SONDERFUNKTION_TEMP1_OK:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
