

;												
; DCF77-Simulator fr ATmega8					
; Bernhard.Erfurt@gmx.de						
; 06/2012										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz	(1MHz)							
; PB7 ==> Quarz	(1MHz)							
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> DCF-AUSGANG							
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT					=1000000			; 1 MHz	
; TIMER-WERTE										
.equ TIMERWERT1				=65536-15625		;(2 hoch 16 minus....15625) bei 1MHz + Vorteiler 64 => 1s 		

.equ DCF_ss					=55
.equ DCF_mm					=58
.equ DCF_hh					=23

.equ DCF_TAG				=31
.equ DCF_MONAT				=12
.equ DCF_JAHR				=12

.equ DCF_WOCHENTAG			=1			; 1=Mo
.equ DCF_SOMMERZEIT			=1
; DCF-PINs										
.equ DCF0_DDR				=DDRD
.equ DCF0_PORT				=PORTD
.equ DCF0_PIN				=0
.equ DCF1_DDR				=DDRD
.equ DCF1_PORT				=PORTD
.equ DCF1_PIN				=1
; LEDS 											
.equ LED_D_GRUEN			= 5
.equ LED_D_GELB				= 6
.equ LED_D_ROT				= 7
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_ERROR_CODE				=0x0060+2		; ERROR CODE vom ersten auftretenden Fehler		

.equ adr_FREIGABE_PROGRAMM		=0x0060+5

.equ adr_ss						=0x0060+10
.equ adr_mm						=0x0060+11
.equ adr_hh						=0x0060+12
.equ adr_TAG					=0x0060+13
.equ adr_MONAT					=0x0060+14
.equ adr_JAHR					=0x0060+15
.equ adr_WOCHENTAG				=0x0060+16			; WochenTag	
.equ adr_SOMMERZEIT				=0x0060+17			; SOMMERZEIT 0/1

.equ adr_DCF_BEREICH			=0x0060+304	 		; 60 BYTES fr DCF-FELD		

; REGISTER										
.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi PORTD,LED_D_GRUEN	; GRN	
	cbi PORTD,LED_D_GELB	; GELB 	
	cbi PORTD,LED_D_ROT		; ROT	
	rcall wait_100ms
	sbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
	sbi PORTD,LED_D_ROT		; ROT	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11100000	; LEDs	
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; DCF_INITIALISIEREN								
	rcall DCF_INITIALISIEREN
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; ZEIT				
	ldi temp,(DCF_SS)
	STS(adr_ss),temp
	ldi temp,(DCF_mm)
	STS(adr_mm),temp
	ldi temp,(DCF_hh)	
	STS(adr_hh),temp
	; DATUM				
	ldi temp,(DCF_TAG)
	STS(adr_TAG)  ,temp		
	ldi temp,(DCF_MONAT)
	STS(adr_MONAT),temp
	ldi temp,(DCF_JAHR)
	STS(adr_JAHR) ,temp
	; Wochentag			
	ldi temp,(DCF_WOCHENTAG)
	STS(adr_WOCHENTAG) ,temp
	; SOMMERZEIT		
	ldi temp,(DCF_SOMMERZEIT)
	STS(adr_SOMMERZEIT) ,temp
	; 	PROGRAMM_CHECK	
	rcall PROGRAMM_CHECK

	sbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
	sbi PORTD,LED_D_ROT		; ROT	
	rcall wait_1s
; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL
	sbi PORTD,LED_D_GELB		; GELB 	
	rcall DCF_BEREICH_BERECHNEN
	rcall DCF_BEREICH_SENDEN
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF77SIMU_DCF.asm"			; DCF77							
.include "DCF77SIMU_TIMER.asm"			; TIMER							
.include "DCF77SIMU_SONSTIGES.asm"		; sonstiges						
.include "DCF77SIMU_WAIT_01MHZ.asm"		;  1 MHz						




